"use strict";
{
    C3.Plugins.Greenworks_Redraw.Instance = class Greenworks_RedrawInstance extends C3.SDKInstanceBase
    {
        constructor(inst, properties)
        {
            super(inst);


            $('html').css(
            {
                'height': "100vh"
            });
            $('body').css(
            {
                'height': "100vh"
            });

            if (properties)
            {
                this.wait = properties[1];
                this.keepRedraw = properties[2] === 0;
                if (this.keepRedraw) this.redraw();
            }
        }

        Release()
        {
            super.Release();
        }

        checkKeepRedraw(nbFrames)
        {
            if (!this.keepRedraw) return;
            if (nbFrames <= 0) this.redraw();
            else requestAnimationFrame(this.checkKeepRedraw.bind(this, nbFrames - 1));
        }

        redraw()
        {
            $('body').css(
            {
                'opacity': 0.999
            });
            requestAnimationFrame(() => {
                $('body').css(
                {
                    'opacity': 1
                });
                this.checkKeepRedraw(this.wait);
            });
        }

        SaveToJson()
        {
            return {
                // data to be saved for savegames
            };
        }

        LoadFromJson(o)
        {
            // load state for savegames
        }

        GetDebuggerProperties()
        {
            return [
            {
                title: "Greenworks_Redraw",
                properties: [
                    //{name: ".current-animation",	value: this._currentAnimation.GetName(),	onedit: v => this.CallAction(Acts.SetAnim, v, 0) },
                ]
            }];
        }
    };
}