"use strict";
{
    C3.Plugins.Greenworks_Redraw.Acts = {
        RedrawBrowserWindow()
        {
            //Prevent starting a new force render loop if one is already running
            if (!this.keepRedraw) this.redraw();
        },

        RedrawBrowserPeriod(period)
        {
            //Prevent starting a new force render loop if one is already running
            if (this.keepRedraw) return;
            this.keepRedraw = true;
            this.redraw();
            setTimeout(function()
            {
                this.keepRedraw = false;
            }, period * 1000);
        },

        ActivateConstantRedraw()
        {
            //Prevent starting a new force render loop if one is already running
            if (this.keepRedraw) return;
            this.keepRedraw = true;
            this.redraw();
        },

        DeactivateConstantRedraw()
        {
            this.keepRedraw = false;
        },

        SetRedrawWait(wait)
        {
            this.wait = wait;
        }
    };
}